<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0"
 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
 xmlns:dp="urn:x-suse:xmlns:docproperties">

 <!-- Use a key, to find the node dp:filename in 'METAFILE' -->
 <xsl:param name="metafilename" select="'METAFILE'"/>
 <xsl:key name="status" match="dp:filename" use="self::dp:filename"/>
 
 
<xsl:template name="getmetadata">
 <xsl:param name="filename" select="'UNKNOWN'"/>
 
 <xsl:variable name="metafilenodes" 
  select="document($metafilename,.)/*/dp:filename"/>
 <xsl:variable name="dpfilenamenode" 
  select="$metafilenodes[generate-id(.) =
  generate-id(key('status', concat('xml/', $filename)))]"/>
 
 <!--<xsl:message>getmetadata: <xsl:value-of 
 select="count($metafilenodes)"/> - <xsl:value-of select="count($dpfilenamenode)"/>
  Filename: <xsl:value-of select="$filename"/>
  Status: <xsl:value-of select="$dpfilenamenode/@status"/>,
   Maintainer: <xsl:value-of select="$dpfilenamenode/@maintainer"/>
   <xsl:if test="$dpfilenamenode/@prelim">
      <xsl:text>, Prelim: </xsl:text>
      <xsl:value-of select="$dpfilenamenode/@prelim"/>
   </xsl:if>
   <xsl:text>)</xsl:text>
 </xsl:message>-->
 
 <span class="docstatus_filename"><xsl:value-of select="$filename"/></span>
 <xsl:text> </xsl:text>
   <xsl:choose>
    <xsl:when test="count($dpfilenamenode) = 0">
     <xsl:text>* UNKNOWN METADATA *</xsl:text>
     <xsl:message>WARNING: Could not retrieve metadata for filename <xsl:value-of 
      select='concat("&apos;", $filename, "&apos;")'/></xsl:message>
    </xsl:when>
    <xsl:otherwise>
     (Status: <xsl:value-of select="$dpfilenamenode/@status"/>,
     Maintainer: <xsl:value-of select="$dpfilenamenode/@maintainer"/>
     <xsl:if test="$dpfilenamenode/@prelim">
      <xsl:text>, Prelim: </xsl:text>
      <xsl:value-of select="$dpfilenamenode/@prelim"/>
     </xsl:if>
     <xsl:text>)</xsl:text>
    </xsl:otherwise>
   </xsl:choose>
</xsl:template>

</xsl:stylesheet>
