<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:dp="urn:x-suse:xmlns:docproperties"
                version="1.0">

<xsl:template match="releaseinfo">
  <xsl:apply-templates/>
</xsl:template>
  

<!-- ==================================================================== -->

<xsl:template name="check.header.link">
  <xsl:param name="node" select="/foo"/>

  <xsl:choose>
    <xsl:when test="generate-id($node/ancestor-or-self::book) = generate-id(ancestor-or-self::book) and
                    count($node)>0">
        <xsl:value-of select="0"/>
    </xsl:when>
    <xsl:otherwise>
        <xsl:value-of select="1"/>
    </xsl:otherwise>
  </xsl:choose>

</xsl:template>


<xsl:template name="get.roottitle">
  <xsl:param name="book" select="ancestor-or-self::book"/>
  <xsl:text>FIXME</xsl:text>
  <!--<xsl:call-template name="suse-pi"/>-->
</xsl:template>


<xsl:template name="insert.home.link">
  <xsl:param name="home"/>
  <xsl:comment>htdig_noindex</xsl:comment>
  <a accesskey="h">
    <xsl:attribute name="href">
      <xsl:call-template name="href.target">
        <xsl:with-param name="object" select="$home"/>
      </xsl:call-template>
    </xsl:attribute>
    <xsl:call-template name="navig.content">
      <xsl:with-param name="direction" select="'home'"/>
    </xsl:call-template>
  </a>
  <xsl:comment>/htdig_noindex</xsl:comment>
</xsl:template>

<xsl:template name="bg.navigation">
  <xsl:param name="node" select="."/>
  
  <xsl:if test="$generate.bgnavi != 0">
    <!--<xsl:message>BG: <xsl:value-of select="name()"/></xsl:message>-->
    <div class="bgnavi">
      <p class="title">Quick Navigation:</p>
      <xsl:choose>
        <xsl:when test="/article">
          <p class="bg-sect1">
          <xsl:for-each select="ancestor-or-self::article/sect1">
              <xsl:apply-templates select="." mode="bgnavi">
                <xsl:with-param name="node" select="$node"/>
              </xsl:apply-templates>
          </xsl:for-each>
          </p>
        </xsl:when>
        <xsl:when test="ancestor-or-self::article">
          <p class="bg-sect1">
          <xsl:for-each select="ancestor-or-self::article">
              <xsl:apply-templates select="." mode="bgnavi">
                <xsl:with-param name="node" select="$node"/>
              </xsl:apply-templates>
          </xsl:for-each>
          </p>
          <p class="bg-section">
            <xsl:apply-templates select="ancestor-or-self::article/sect1" mode="bgnavi">
              <xsl:with-param name="node" select="$node"/>
            </xsl:apply-templates>
          </p>
        </xsl:when>
        <xsl:otherwise>
          <p class="bg-part">
            <xsl:for-each select="ancestor-or-self::book/part">
              <xsl:apply-templates select="." mode="bgnavi">
                <xsl:with-param name="node" select="$node"/>
              </xsl:apply-templates>
            </xsl:for-each>
            
          </p>
          <p class="bg-chapter">
            <xsl:apply-templates select="ancestor-or-self::part/chapter" mode="bgnavi">
              <xsl:with-param name="node" select="$node"/>
            </xsl:apply-templates>
          </p>
        </xsl:otherwise>
      </xsl:choose>
    </div>
  </xsl:if>
</xsl:template>

<xsl:template match="text()" mode="bgnavi"/>

<xsl:template match="part" mode="bgnavi">
  <xsl:param name="node" select="."/>
  
  <span>
    <xsl:choose>
        <xsl:when
          test="generate-id(.) = generate-id($node/ancestor-or-self::part)">
          <xsl:attribute name="class">bg-part-current</xsl:attribute>
          <xsl:apply-templates select="self::part" mode="division.number"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="class">bg-part</xsl:attribute>
          <a>
            <xsl:attribute name="href">
              <xsl:call-template name="href.target">
                <xsl:with-param name="object" select="."/>
              </xsl:call-template>
            </xsl:attribute>
            <xsl:attribute name="title">
              <xsl:apply-templates select="."
                mode="object.title.markup"/>
            </xsl:attribute>
            <xsl:apply-templates select="self::part" mode="division.number"/>
          </a>
        </xsl:otherwise>
      </xsl:choose>
  </span>
  <xsl:text> </xsl:text>
</xsl:template>

<xsl:template match="chapter" mode="bgnavi">
  <xsl:param name="node" select="."/>
  <xsl:variable name="num">
    <xsl:apply-templates select="self::chapter" mode="label.markup"/>
  </xsl:variable>
  
    <span>
      <xsl:choose>
        <xsl:when
          test="generate-id(.) = generate-id($node/ancestor-or-self::chapter)">
          <xsl:attribute name="class">bg-chapter-current</xsl:attribute>
          <xsl:value-of select="$num"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="class">bg-chapter</xsl:attribute>
          <a>
            <xsl:attribute name="href">
              <xsl:call-template name="href.target">
                <xsl:with-param name="object" select="."/>
              </xsl:call-template>
            </xsl:attribute>
            <xsl:attribute name="title">
              <xsl:apply-templates select="."
                mode="object.title.markup"/>
            </xsl:attribute>
            <xsl:value-of select="$num"/>
          </a>
        </xsl:otherwise>
      </xsl:choose>
    </span>
  <xsl:text> </xsl:text>
</xsl:template>

<xsl:template match="article" mode="bgnavi">
   <xsl:param name="node" select="."/>
   <xsl:variable name="num">
    <xsl:apply-templates select="self::article" mode="label.markup"/>
   </xsl:variable>
  
  <span>
    <xsl:choose>
      <xsl:when
        test="generate-id(.) = generate-id($node/ancestor-or-self::sect1)">
        <xsl:attribute name="class">bg-article-current</xsl:attribute>
        <xsl:value-of select="$num"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:attribute name="class">bg-article</xsl:attribute>
        <a>
          <xsl:attribute name="href">
            <xsl:call-template name="href.target">
              <xsl:with-param name="object" select="."/>
            </xsl:call-template>
          </xsl:attribute>
          <xsl:attribute name="title">
            <xsl:apply-templates select="." 
              mode="object.title.markup"/>
          </xsl:attribute>
          <xsl:value-of select="$num"/>
        </a>
        <xsl:text> </xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </span>
</xsl:template>

<xsl:template match="sect1" mode="bgnavi">
  <xsl:param name="node" select="."/>
  <xsl:variable name="num">
    <xsl:apply-templates select="self::sect1" mode="label.markup"/>
  </xsl:variable>

    <span>
      <xsl:choose>
        <xsl:when
          test="generate-id(.) = generate-id($node/ancestor-or-self::sect1)">
          <xsl:attribute name="class">bg-sect1-current</xsl:attribute>
          <xsl:value-of select="$num"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:attribute name="class">bg-sect1</xsl:attribute>
          <a>
            <xsl:attribute name="href">
              <xsl:call-template name="href.target">
                <xsl:with-param name="object" select="."/>
              </xsl:call-template>
            </xsl:attribute>
            <xsl:attribute name="title">
              <xsl:apply-templates select="." 
                mode="object.title.markup"/>
            </xsl:attribute>
            <xsl:value-of select="$num"/>
          </a>
          <xsl:text> </xsl:text>
        </xsl:otherwise>
      </xsl:choose>
    </span>
</xsl:template>


<xsl:template name="generate.link.line">
    <xsl:param name="prev" select="/foo"/>
    <xsl:param name="next" select="/foo"/>
    <xsl:param name="nav.context"/>
    <xsl:param name="orientation"/>
    
    <xsl:if test="$suppress.navigation = '0' and
                  $suppress.header.navigation = '0' and
                  not(self::set)">
      <!-- FIXME: Watch for $rootid -->
      
      <div class="nav{$orientation}">
        <xsl:if test="$orientation = 'footer' and $footer.rule != 0">
          <hr/>
        </xsl:if>
        
        <table width="100%" summary="Navigation {$orientation}" border="0" 
          class="bctable">
          <tr>
            <td width="80%">
              <xsl:call-template name="breadcrumbs.navigation">
                <xsl:with-param name="prev" select="$prev"/>
                <xsl:with-param name="next" select="$next"/>
              </xsl:call-template>
            </td>
            <td width="20%">
              <xsl:call-template name="bg.navigation"/>
            </td>
          </tr>
        </table>
        
        <xsl:if test="$orientation = 'header' and $header.rule != 0">
          <hr/>
        </xsl:if>
      </div>
      
    </xsl:if>
    
</xsl:template>
  

<xsl:template name="breadcrumbs.navigation">
    <xsl:param name="prev"/>
    <xsl:param name="next"/>
    
  <xsl:variable name="prevresult">
    <xsl:call-template name="check.header.link">
      <xsl:with-param name="node" select="$prev"/>
    </xsl:call-template>
  </xsl:variable>
    
    
    <xsl:if test="$generate.breadcrumbs != 0">
      <div class="breadcrumbs">
        <p>
          <xsl:for-each select="ancestor::*">
            <xsl:element name="a">
              <xsl:attribute name="href">
                <xsl:call-template name="href.target">
                  <xsl:with-param name="object" select="."/>
                  <xsl:with-param name="context" select="."/>
                </xsl:call-template>
              </xsl:attribute>
              <xsl:apply-templates select="." mode="title.markup"/>
            </xsl:element>
            <span class="breadcrumbs-sep"><xsl:copy-of select="$breadcrumbs.separator"/></span>
          </xsl:for-each>
          <xsl:if test="self::* != /*">
            <strong>
              <xsl:if test="$prevresult=0">
                <a accesskey="p">
                  <xsl:attribute name="title">
                    <xsl:apply-templates select="$prev" mode="object.title.markup"/>
                  </xsl:attribute>
                  <xsl:attribute name="href">
                    <xsl:call-template name="href.target">
                      <xsl:with-param name="object" select="$prev"/>
                    </xsl:call-template>
                  </xsl:attribute>
                  <span><xsl:copy-of select="$breadcrumbs.prev"/></span>
                  <!--<xsl:call-template name="navig.content">
                    <xsl:with-param name="direction" select="'prev'"/>
                  </xsl:call-template>-->
                </a>
                <xsl:text> </xsl:text>
              </xsl:if>
              <xsl:if test="count($next)>0">
                <xsl:text> </xsl:text>
                <a accesskey="n">
                  <xsl:attribute name="title">
                    <xsl:apply-templates select="$next" mode="object.title.markup"/>
                  </xsl:attribute>
                  <xsl:attribute name="href">
                    <xsl:call-template name="href.target">
                      <xsl:with-param name="object" select="$next"/>
                    </xsl:call-template>
                  </xsl:attribute>
                  <span><xsl:copy-of select="$breadcrumbs.next"/></span>
                  <!--<xsl:call-template name="navig.content">
                    <xsl:with-param name="direction" select="'next'"/>
                  </xsl:call-template>-->
                </a>
              </xsl:if>
              <!--<xsl:apply-templates select="." mode="title.markup"/>-->
            </strong>
          </xsl:if>
        </p>
      </div>
    </xsl:if>
</xsl:template>
  

<xsl:template name="generate.link.line__">
  <xsl:param name="prev" select="/foo"/>
  <xsl:param name="next" select="/foo"/>
  <xsl:param name="nav.context"/>
  <xsl:param name="orientation"/>

  <xsl:variable name="prevbook"
    select="generate-id($prev/ancestor-or-self::book)"/>
  <xsl:variable name="nextbook"
    select="generate-id($next/ancestor-or-self::book)"/>
  <xsl:variable name="thisbook"
    select="generate-id(ancestor-or-self::book)"/>
  
  <xsl:variable name="prevname" select="local-name($prev)"/>
  <xsl:variable name="nextname" select="local-name($next)"/>
  
  <!--  <xsl:variable name="keyrootid" select="key('id', $rootid)"/>
    <xsl:variable name="ancbook.rootid" select="$keyrootid/ancestor-or-self::book"/>-->
  
  <xsl:variable name="home" select="/*[1]"/>
  <xsl:variable name="up" select="parent::*"/>
  
  <xsl:variable name="row1" select="$navig.showtitles != 0"/>
  <xsl:variable name="row2" select="count($prev) > 0
    or (count($up) > 0
    and $up != $home
    and $navig.showtitles != 0)
    or count($next) > 0"/>
  <xsl:variable name="prevresult">
    <xsl:call-template name="check.header.link">
      <xsl:with-param name="node" select="$prev"/>
    </xsl:call-template>
  </xsl:variable>
  
  <xsl:message>
    prevname = <xsl:value-of select="local-name($prev)"/>
    nextname = <xsl:value-of select="local-name($next)"/>
    prevresult = <xsl:value-of select="$prevresult"/>
    count($prev) = <xsl:value-of select="count($prev)"/>
    
    next     = <xsl:value-of select="generate-id($next)"/>
    nextbook = <xsl:value-of select="$nextbook"/>
    
    thisbook = <xsl:value-of select="$thisbook"/>
    nodename = <xsl:value-of select="name(.)"/>
    id(nodename) = <xsl:value-of select="generate-id(.)"/>
    
    prev     = <xsl:value-of select="generate-id($prev)"/>
    prevbook = <xsl:value-of select="$prevbook"/>
  </xsl:message>
  

  <xsl:if test="$suppress.navigation = '0' and
    $suppress.header.navigation = '0' and
    not(self::set)">
    
    <div class="nav{$orientation}">
      <xsl:if test="$orientation = 'footer' and $footer.rule != 0">
        <hr/>
      </xsl:if>
      
      <xsl:if test="$row1 or $row2">
        <table width="100%" summary="Navigation {$orientation}" border="0">
          <xsl:if test="$row1">
            <tr>
              <th colspan="5" align="center">
                <xsl:variable name="objecttitle">
                  <xsl:apply-templates select="." mode="object.title.markup"/>
                </xsl:variable>
                <!--<xsl:value-of select="/*/title"/>-->
                <xsl:call-template name="get.roottitle"/>
                
                <!-- &nbsp;&ndash;&nbsp; -->
                <!--<xsl:if test="/*/subtitle">
                  <xsl:text>&#160;&#x2013;&#160;</xsl:text>
                  <xsl:value-of select="/*/subtitle"/>
                  </xsl:if>-->
                <br/>
                <xsl:choose>
                  <xsl:when test="count($up) > 0
                    and $up != $home
                    and $navig.showtitles != 0">
                    
                    <xsl:text>&#160;/&#160;</xsl:text>
                  </xsl:when>
                  <xsl:otherwise>&#160;</xsl:otherwise>
                </xsl:choose>
                <xsl:choose>
                  <!-- Don't use another line, if it's an article -->
                  <xsl:when test="self::article or
                    local-name(key('id',$rootid)) = 'article'"/>
                  
                  <xsl:otherwise>
                    <xsl:if test="normalize-space($objecttitle) != normalize-space(/*/title)">
                      <xsl:comment>htdig_noindex</xsl:comment>
                      <xsl:apply-templates select="." mode="object.title.markup"/>
                      <xsl:comment>/htdig_noindex</xsl:comment>
                    </xsl:if>                     
                  </xsl:otherwise>
                </xsl:choose>
              </th>
            </tr>
          </xsl:if>
          
          <xsl:if test="$row2">
            <tr>
              <td width="5%" align="left" valign="center">
                <xsl:if test="$prevresult=0">
                  <xsl:comment>htdig_noindex</xsl:comment>
                  <a accesskey="p">
                    <xsl:attribute name="href">
                      <xsl:call-template name="href.target">
                        <xsl:with-param name="object" select="$prev"/>
                      </xsl:call-template>
                    </xsl:attribute>
                    <xsl:call-template name="navig.content">
                      <xsl:with-param name="direction" select="'prev'"/>
                    </xsl:call-template>
                  </a>
                  <xsl:comment>/htdig_noindex</xsl:comment>
                </xsl:if>
              </td>
              <td width="40%" align="left" valign="center">
                <xsl:if test="$navig.showtitles != 0 and $prevresult=0"> <!--$navig.showtitles != 0 and -->
                  <xsl:comment>htdig_noindex</xsl:comment>
                  <a accesskey="p">
                    <xsl:attribute name="href">
                      <xsl:call-template name="href.target">
                        <xsl:with-param name="object" select="$prev"/>
                      </xsl:call-template>
                    </xsl:attribute>
                    <xsl:apply-templates select="$prev" mode="object.title.markup"/>
                  </a>
                  <xsl:comment>/htdig_noindex</xsl:comment>
                </xsl:if>
              </td>
              <td width="10%" align="center" valign="center">
                <xsl:choose>
                  <xsl:when test="$thisbook != generate-id(.) and
                    ($home != . or $nav.context = 'toc')">
                    <xsl:call-template name="insert.home.link">
                      <xsl:with-param name="home" select="$home"/>
                    </xsl:call-template>
                    <xsl:if test="count($up)&gt;0
                                  and generate-id($up) != generate-id($home)">
                        <a accesskey="u">
                          <xsl:attribute name="href">
                            <xsl:call-template name="href.target">
                              <xsl:with-param name="object" select="$up"
                              />
                            </xsl:call-template>
                          </xsl:attribute>
                          <xsl:call-template name="navig.content">
                            <xsl:with-param name="direction"
                              select="'up'"/>
                          </xsl:call-template>
                        </a>
                    </xsl:if>
                    <xsl:if test="$chunk.tocs.and.lots != 0 and $nav.context != 'toc'">
                      <xsl:text>&#160;|&#160;</xsl:text>
                    </xsl:if>
                  </xsl:when>
                  <xsl:otherwise/>
                </xsl:choose>
              </td>
              
              <td width="40%" align="right" valign="center">
                <xsl:if test="$navig.showtitles != 0 and 
                  count($next)>0 and 
                  $nextname != 'book'">
                  <xsl:comment>htdig_noindex</xsl:comment>
                  <a accesskey="n">
                    <xsl:attribute name="href">
                      <xsl:call-template name="href.target">
                        <xsl:with-param name="object" select="$next"/>
                      </xsl:call-template>
                    </xsl:attribute>
                    <xsl:apply-templates select="$next" mode="object.title.markup"/>
                  </a>
                  <xsl:comment>/htdig_noindex</xsl:comment>
                </xsl:if>
              </td>
              <td width="5%" align="right" valign="center">
                <xsl:if test="count($next)>0 and
                  $nextname != 'book'">
                  <xsl:comment>htdig_noindex</xsl:comment>
                  <a accesskey="n">
                    <xsl:attribute name="href">
                      <xsl:call-template name="href.target">
                        <xsl:with-param name="object" select="$next"/>
                      </xsl:call-template>
                    </xsl:attribute>
                    <xsl:call-template name="navig.content">
                      <xsl:with-param name="direction" select="'next'"/>
                    </xsl:call-template>
                  </a>
                  <xsl:comment>/htdig_noindex</xsl:comment>
                </xsl:if>
              </td>
            </tr>
          </xsl:if>
          <xsl:if test="$use.meta != 0">
            <xsl:variable name="xmlbase.filename"
              select="(ancestor-or-self::chapter|
              ancestor-or-self::preface|
              ancestor-or-self::appendix|
              ancestor-or-self::glossary)/@xml:base"/>
            <tr>
              <td colspan="5" align="center" class="docstatus">
                <xsl:comment>htdig_noindex</xsl:comment>
                <xsl:call-template name="getmetadata">
                  <xsl:with-param name="filename" select="$xmlbase.filename"/>
                </xsl:call-template>
                <xsl:comment>/htdig_noindex</xsl:comment>
              </td>
            </tr>
          </xsl:if>
        </table>
      </xsl:if>
      <xsl:if test="$orientation = 'header' and $header.rule != 0">
        <hr/>
      </xsl:if>
    </div>
  </xsl:if>
</xsl:template>


<!-- ==================================================================== -->
  
<xsl:template name="header.navigation">
  <xsl:param name="prev" select="/foo"/>
  <xsl:param name="next" select="/foo"/>
  <xsl:param name="nav.context"/>

  <!-- Generate header navigation, if link  -->
  <xsl:if test="self::* != (key('id', $rootid) | /*)[1]">
    <xsl:call-template name="generate.link.line">
      <xsl:with-param name="nav.context" select="$nav.context"/>
      <xsl:with-param name="next" select="$next"/>
      <xsl:with-param name="prev" select="$prev"/>
      <xsl:with-param name="orientation" select="'header'"/>
    </xsl:call-template>
  </xsl:if>
</xsl:template>


<xsl:template name="footer.navigation">
  <xsl:param name="prev" select="/foo"/>
  <xsl:param name="next" select="/foo"/>
  <xsl:param name="nav.context"/>

  <xsl:call-template name="generate.link.line">
    <xsl:with-param name="nav.context" select="$nav.context"/>
    <xsl:with-param name="next" select="$next"/>
    <xsl:with-param name="prev" select="$prev"/>
    <xsl:with-param name="orientation" select="'footer'"/>
  </xsl:call-template>

</xsl:template>

<!-- ==================================================================== -->


<xsl:template name="user.header.content">
  <xsl:choose>
    <xsl:when test="self::set">
      <div class="logo">
        <xsl:text> LOGO </xsl:text>
      </div>
    </xsl:when>
    <xsl:otherwise>
      <!--<xsl:call-template name="breadcrumbs.navigation"/>-->
    </xsl:otherwise>
  </xsl:choose>
  
</xsl:template>


  
<xsl:template name="user.footer.content">
  <!--<xsl:message> user.footer.content </xsl:message>-->
  
   <xsl:if test="/book/bookinfo/productnumber">
      <div class="userfootercontent">
       <xsl:comment>htdig_noindex</xsl:comment>
       <hr/>
       <center>
         <xsl:value-of select="/book/bookinfo/productname" />
         <xsl:text> </xsl:text>
         <xsl:value-of select="/book/bookinfo/titleabbrev"/>
         <xsl:text> </xsl:text>
         <xsl:value-of select="/book/bookinfo/productnumber" />
       </center>
       <xsl:comment>/htdig_noindex</xsl:comment>
      </div>
   </xsl:if>
</xsl:template>


<!-- Something that we can consider in the future: -->
<!--<xsl:template name="user.footer.navigation">
  <xsl:message>user.footer.navigation</xsl:message>
   <div class="userfooternavigation">
      <table width="100%" >
      <tbody>
         <tr width="50%">
         <td><a style="text-align:right;"
   href="http://www.suse.de/en/company/index.html">About SUSE</a>
         </td>
         <td width="50%"><a
   href="ln-copyright.html">Legal notice</a>
         </td>
         </tr>
      </tbody>
      </table>
   </div>
</xsl:template>
-->

</xsl:stylesheet>
